%define major_ver 1.18
%define ver %{major_ver}.0
%define rel 1

Summary:	Background images and data for MATE
Name:		mate-backgrounds
Version:	%{ver}
Release:	%{rel}%{?_dist_release}
Source:		http://pub.mate-desktop.org/releases/%{major_ver}/%{name}-%{version}.tar.xz
License:	GPLv2
Group:		User Interface/Desktops
URL:		http://mate-desktop.org/
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}-root

BuildRequires:	mate-common
BuildRequires:	glib2-devel
BuildRequires:	autoconf
BuildRequires:	automake

Requires:	vine-backgrounds

Vendor:         Project Vine
Distribution:   Vine Linux
Packager:       Takemikaduchi, iwaim

%description
This module contains a set of backgrounds packaged with the MATE desktop.

%prep
%setup -q

%build
(if ! test -x configure; then NOCONFIGURE=1 ./autogen.sh; fi)
%configure
%{__make}

%install
%{__rm} -rf ${RPM_BUILD_ROOT}
%{__make} install DESTDIR=${RPM_BUILD_ROOT}

ln -sf ../gnome-background-properties/vine-nature.xml ${RPM_BUILD_ROOT}%{_datadir}/mate-background-properties/vine-nature.xml
ln -sf ../gnome-background-properties/vine6.xml ${RPM_BUILD_ROOT}%{_datadir}/mate-background-properties/vine6.xml

%find_lang %{name}

%files -f %{name}.lang
%defattr(-, root, root)
%doc COPYING AUTHORS ChangeLog NEWS README TODO
%{_datadir}/mate-background-properties
%{_datadir}/backgrounds/mate

%changelog
* Sat Apr  8 2017 IWAI, Masaharu <iwaim.sub@gmail.com> 1.18.0-1
- update to 1.18.0

* Sun Nov 27 2016 IWAI, Masaharu <iwaim.sub@gmail.com> 1.16.0-1
- new upstream release
- update Packager

* Sun May 08 2016 Yoji TOYODA <bsyamato@sea.plala.or.jp> 1.14.0-1
- new upstream release

* Sat Nov 07 2015 Yoji TOYODA <bsyamato@sea.plala.or.jp> 1.12.0-1
- new upstream release

* Sat May 09 2015 Yoji TOYODA <bsyamato@sea.plala.or.jp> 1.10.0-1
- new upstream release

* Mon Apr 14 2014 Yoji TOYODA <bsyamato@sea.plala.or.jp> 1.8.0-1
- new upstream release

* Sun Dec 29 2013 Yoji TOYODA <bsyamato@sea.plala.or.jp> 1.6.0-2
- rebuild with VineSeed environment

* Sun May 19 2013 Yoji TOYODA <bsyamato@sea.plala.or.jp> 1.6.0-1
- new upstream release

* Wed Aug 01 2012 Yoji TOYODA <bsyamato@sea.plala.or.jp> 1.4.0-1
- new upstream release

* Sat May 12 2012 Yoji TOYODA <bsyamato@sea.plala.or.jp> 1.2.1-1
- new upstream release

* Fri Dec 23 2011 Yoji TOYODA <bsyamato@sea.plala.or.jp> 1.1.0-2
- change category

* Fri Dec 23 2011 Yoji TOYODA <bsyamato@sea.plala.or.jp> 1.1.0-1
- initial build for Vine Linux

